GTGList.h File Reference

Go to the source code of this file.

## Data Structures

struct | gtg_list

## Macros

#define | GTG_LIST_INIT(ptr)
| initialize a list.
#define | GTG_LIST(name)
| declare and initialize a list.
#define | gtg_list_entry(ptr, type, member) ((type *)((char *)(ptr) - (char *)(&((type *)0)->member)))
| get the structure corresponding to a list entry
#define | gtg_list_for_each(pos, head) for (pos = (head)->next; pos != (head); pos = pos->next)
#define | gtg_list_for_each_reverse(pos, head) for (pos = (head)->prev; pos != (head); pos = pos->prev)
#define | gtg_list_for_each_safe(pos, n, head)
#define | gtg_list_for_each_entry(pos, head, member)
| iterate over list of given type
#define | gtg_list_for_each_entry_safe(pos, n, head, member)
| iterate over list of given type safe against removal of list entry

## Typedefs

typedef struct gtg_list * | gtg_list_t

## Functions

static void | __gtg_list_add (gtg_list_t lnew, gtg_list_t prev, gtg_list_t next)
static void | gtg_list_add (gtg_list_t lnew, gtg_list_t head)
| Insert a new entry after the specified head.
static void | gtg_list_add_tail (gtg_list_t lnew, gtg_list_t head)
| Insert a new entry before the specified head (ie. at the tail of the list).
static void | __gtg_list_del (gtg_list_t prev, gtg_list_t next)
static void | gtg_list_del (gtg_list_t entry)
| delete an entry from its list and reinitialize it.
static int | gtg_list_size (gtg_list_t l)

## Macro Definition Documentation

## GTG_LIST

GTG_LIST | ( |  | name | ) |

Value:
struct gtg_list name; \
GTG_LIST_INIT(&name)
gtg_list
Definition GTGList.h:4

declare and initialize a list.

Parameters

  name | Name of the variable

## gtg_list_entry

gtg_list_entry | ( |  | ptr,
|  |  | type,
|  |  | member
| ) |  | ((type *)((char *)(ptr) - (char *)(&((type *)0)->member)))

get the structure corresponding to a list entry

Parameters

  ptr | pointer to the list entry (gtg_list_t)
  type | the type of the struct this is embedded in.
  member | the name of the struct gtg_list member within the struct.

## gtg_list_for_each

#define gtg_list_for_each | ( |  | pos,
|  |  | head
| ) |  | for (pos = (head)->next; pos != (head); pos = pos->next)

## gtg_list_for_each_entry

#define gtg_list_for_each_entry | ( |  | pos,
|  |  | head,
|  |  | member
| ) |  |

Value:
for (pos = gtg_list_entry((head)->next, typeof(*pos), member); \
&pos->member != (head); \
pos = gtg_list_entry(pos->member.next, typeof(*pos), member))
gtg_list_entry
#define gtg_list_entry(ptr, type, member)
get the structure corresponding to a list entry
Definition GTGList.h:39

iterate over list of given type

gtg_list_for_each_entry(pos, head, member)

Parameters

  pos | the type * to use as a loop counter.
  head | the head for the list.
  member | the name of the struct gtg_list member within the struct.

## gtg_list_for_each_entry_safe

#define gtg_list_for_each_entry_safe | ( |  | pos,
|  |  | n,
|  |  | head,
|  |  | member
| ) |  |

Value:
for (pos = gtg_list_entry((head)->next, typeof(*pos), member), \
n = gtg_list_entry(pos->member.next, typeof(*pos), member); \
&pos->member != (head); \
pos = n, n = gtg_list_entry(n->member.next, typeof(*n), member))

iterate over list of given type safe against removal of list entry

gtg_list_for_each_entry_safe(pos, n, head, member)

Parameters

  pos | the type * to use as a loop counter.
  n | another type * to use as temporary storage
  head | the head for the list.
  member | the name of the struct gtg_list member within the struct.

## gtg_list_for_each_reverse

#define gtg_list_for_each_reverse | ( |  | pos,
|  |  | head
| ) |  | for (pos = (head)->prev; pos != (head); pos = pos->prev)

## gtg_list_for_each_safe

#define gtg_list_for_each_safe | ( |  | pos,
|  |  | n,
|  |  | head
| ) |  |

Value:
for (pos = (head)->next, n = pos->next; pos != (head); \
pos = n, n = pos->next)

## GTG_LIST_INIT

GTG_LIST_INIT | ( |  | ptr | ) |

Value:
do { \
(ptr)->prev = (ptr); \
(ptr)->next = (ptr); \
} while(0)

initialize a list.

Parameters

  ptr | pointer to the list (gtg_list_t).

## Typedef Documentation

## gtg_list_t

typedef struct gtg_list* gtg_list_t

## Function Documentation

## __gtg_list_add()

static void __gtg_list_add | ( | gtg_list_t | lnew,
|  | gtg_list_t | prev,
|  | gtg_list_t | next
| ) |  |

inline static

## __gtg_list_del()

static void __gtg_list_del | ( | gtg_list_t | prev,
|  | gtg_list_t | next
| ) |  |

inline static

Delete a list entry by making the prev/next entries point to each other.

This is only for internal list manipulation where we know the prev/next entries already!

## gtg_list_add()

void gtg_list_add | ( | gtg_list_t | lnew,
|  | gtg_list_t | head
| ) |  |

inline static

Insert a new entry after the specified head.

Parameters

  lnew | new entry to be added
  head | list head to add it after

## gtg_list_add_tail()

void gtg_list_add_tail | ( | gtg_list_t | lnew,
|  | gtg_list_t | head
| ) |  |

inline static

Insert a new entry before the specified head (ie. at the tail of the list).

Parameters

  lnew | new entry to be added
  head | list head to add it after

## gtg_list_del()

void gtg_list_del | ( | gtg_list_t | entry | ) |

inline static

delete an entry from its list and reinitialize it.

Parameters

  entry | the element to delete from the list.

## gtg_list_size()

static int gtg_list_size | ( | gtg_list_t | l | ) |

inline static